function g=gap(A,B)
% function g=gap(A,B)
% P.Comon, 17 June, 1998
% Distance minimale entre 2 matrices complexes 2x3 a une
% permutation-echelle 3x3 pres
% g est la distance de Froebenius (racine de la somme des carres des 
% composantes) entre A et B*D, pour la matrice de permutation generalisee
% D optimale (matrice permutation*echelle complexe 3x3).

[m,n]=size(A);[p,q]=size(B);
%if m>n, A=A.';[m,n]=size(A);end;if p>q, B=B.';[p,q]=size(B);end;
if p~=2|m~=2|n~=3|q~=3, error('les matrices doivent etre 2x3');end;

%% NEUTRALISATION DE LA PERMUTATION %%
G=[];
for i=1:3,I=1:3;I(i)=[];
j=I(1);k=I(2);
D1=distechel(A(:,1),B(:,i));
D2=distechel(A(:,2),B(:,j));
D3=distechel(A(:,3),B(:,k));
G=[G (D1+D2+D3)];  
j=I(2);k=I(1);
D1=distechel(A(:,1),B(:,i));
D2=distechel(A(:,2),B(:,j));
D3=distechel(A(:,3),B(:,k));
G=[G (D1+D2+D3)];
end;

g=sqrt(min(G));

